/*
*        main program
*/
#include "minigui.ch"
#include "common.ch"
#include "adordd.ch"
#include "hboo.ch"

#include "l3w_adodbmys.prg"

#include "mainp001.prg"
#include "mainp002.prg"
#include "mainp003.prg"

FUNCTION main()
REQUEST HB_CODEPAGE_IT437
REQUEST HB_CODEPAGE_IT850
REQUEST HB_CODEPAGE_ITISO
REQUEST HB_CODEPAGE_ITISB

HB_LANGSELECT("IT")
HB_SETCODEPAGE( "ITISB" )

  p000_main()
RETURN NIL

/*
*        main loop
*/
STATIC FUNCTION p000_main()

/*
* this var it's necessary to share the connection along the project/programs
* If You have more than one, put here and You can use in all your sub programs/functions
*/
oPrjcon := TOleauto():New('ADODB.Connection')

/*
* this var it's necessary only for this test program: You can invent or use other way to know if connected
*/
lConnect := .F.

DEFINE WINDOW p000win ;
  AT 0,0 ;
  WIDTH 940 ;
  HEIGHT 705 ;
  TITLE "HMG and MySql" ;
  ICON 'icologo' ;
  MAIN ;
  ON INIT p000_login() ;
  ON RELEASE p000_exit() ;
  FONT "Arial" ;
  SIZE 10

  DEFINE MAIN MENU
    DEFINE POPUP '&File'
      MENUITEM 'e&Xit' ACTION p000win.release
    END POPUP
    DEFINE POPUP '&Create Table'
      MENUITEM '&Tbtest' ACTION {|| IF (lConnect==.T.,p001_main(),NIL)}
    END POPUP
    DEFINE POPUP '&Records'
      MENUITEM '&Maintenance' ACTION {|| IF (lConnect==.T.,p002_main(),NIL)}
    END POPUP
  END MENU

END WINDOW
CENTER WINDOW p000win
ACTIVATE WINDOW p000win

RETURN NIL

/*
*	user connect (if can) database that MUST EXIST
* see function l3w_AdoConOpen
* note about _oConnection := oPrjcon and l3w_AdoConOpen(@_oConnection...:
* I prefer this way because I can have more than one active connection and I can invoke AdoConOpen more than one at time
*/
STATIC FUNCTION p000_login()
LOCAL _aPrmcon := {}
LOCAL _oConnection := oPrjcon
* 1st is user name
AADD( _aPrmcon, "l3wadmin" )
* 2nd is user password
AADD( _aPrmcon, "l3wadmin" )
* 3rd is server name | IP address | localhost
AADD( _aPrmcon, "MyWeb" )
* 4th is driver name installed on pc where run this application
AADD( _aPrmcon, "{Mysql ODBC 3.51 Driver}" )
* 5th is dsn not used with MySql
AADD( _aPrmcon, "" )
* 6th is database name
AADD( _aPrmcon, "hmgtest" )
* 7th is database option read Mysql documentation
AADD( _aPrmcon, "35" )

MSGSTOP("I'm trying to connect")
IF l3w_AdoConOpen(@_oConnection, _aPrmcon) == .T.
  oPrjcon := _oConnection
  lConnect := .T.
  MSGSTOP("Connected")
ELSE
  MSGSTOP("I'm sorry: you can't access")
  p000win.release
ENDIF
RETURN NIL

/*
*	uscita dal programma
*/
STATIC FUNCTION p000_exit()
l3w_AdoConClose(@oPrjcon)
RETURN NIL
